<?php
namespace Opencart\Admin\Controller\Extension\IdPaymentBerekeBank\Payment;
use Opencart\Catalog\Model\Extension\IdPaymentBerekeBank\Payment\Gateway;
use Opencart\System\Library\Url;
use Opencart\System\Library\Session;
include_once( DIR_EXTENSION.'id_payment_berekebank/system/library/Gateway.php' );
class BerekeBankPayment extends \Opencart\System\Engine\Controller {
public function index(): void {
$this->load->language('extension/id_payment_berekebank/payment/berekebank_payment');
$Gateway = new Gateway();
$this->document->setTitle($Gateway->method_title);
$data['breadcrumbs'] = [];
$data['breadcrumbs'][] = [
'text' => $this->language->get('text_home'),
'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'])
];
$data['breadcrumbs'][] = [
'text' => $this->language->get('text_extension'),
'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment')
];
$data['breadcrumbs'][] = [
'text' => $Gateway->method_title,
'href' => $this->url->link('extension/id_payment_berekebank/payment/berekebank_payment', 'user_token=' . $this->session->data['user_token'])
];
$data['save'] = $this->url->link('extension/id_payment_berekebank/payment/berekebank_payment.save', 'user_token=' . $this->session->data['user_token']);
$data['back'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment');
$data['payment_berekebank_payment_response'] = $this->config->get('payment_berekebank_payment_response');
$data['payment_berekebank_payment_approved_status_id'] = $this->config->get('payment_berekebank_payment_approved_status_id');
$data['payment_berekebank_payment_failed_status_id'] = $this->config->get('payment_berekebank_payment_failed_status_id');
$this->load->model('localisation/order_status');
$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
$data['payment_berekebank_payment_geo_zone_id'] = $this->config->get('payment_berekebank_payment_geo_zone_id');
$this->load->model('localisation/geo_zone');
$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();
$data['payment_berekebank_payment_status'] = $this->config->get('payment_berekebank_payment_status');
$data['payment_berekebank_payment_sort_order'] = $this->config->get('payment_berekebank_payment_sort_order');
$data['payment_berekebank_payment_method_title'] = $this->config->get('payment_berekebank_payment_method_title');
$data['payment_berekebank_payment_merchant_token'] = $this->config->get('payment_berekebank_payment_merchant_token');
$data['payment_berekebank_payment_merchant_login'] = $this->config->get('payment_berekebank_payment_merchant_login');
$data['payment_berekebank_payment_merchant_password'] = $this->config->get('payment_berekebank_payment_merchant_password');
if (!empty($data['payment_berekebank_payment_merchant_login']) && !empty($data['payment_berekebank_payment_merchant_password'])) {
$token_default = base64_encode($data['payment_berekebank_payment_merchant_login'] . ":" . $data['payment_berekebank_payment_merchant_password']);
$data['payment_berekebank_payment_merchant_token'] = $token_default;
}
$data['payment_berekebank_payment_test_mode'] = $this->config->get('payment_berekebank_payment_test_mode');
$data['payment_berekebank_payment_stage_mode'] = $this->config->get('payment_berekebank_payment_stage_mode');
$data['enable_refund_options'] = $Gateway->enable_refund_options;
$data['enable_back_url_settings'] = $Gateway->enable_back_url_settings;
$data['payment_berekebank_payment_backToShopUrl'] = $this->config->get('payment_berekebank_payment_backToShopUrl');
$data['enable_cart_options'] = $Gateway->enable_cart_options;
$data['api_version'] = $Gateway->api_version;
$data['payment_berekebank_payment_reversed_status_id'] = $this->config->get('payment_berekebank_payment_reversed_status_id');
$data['payment_berekebank_payment_refunded_status_id'] = $this->config->get('payment_berekebank_payment_refunded_status_id');
$data['payment_berekebank_payment_send_cart_status'] = $this->config->get('payment_berekebank_payment_send_cart_status');
$data['taxSystem_list'] = $this->getTaxSystemList();
$data['payment_berekebank_payment_tax_system'] = $this->config->get('payment_berekebank_payment_tax_system');
$data['taxType_list'] = $this->getTaxTypeList();
$data['payment_berekebank_payment_tax_type'] = $this->config->get('payment_berekebank_payment_tax_type');
$data['versionFfd_list'] = $this->getVersionFfdList();
$data['payment_berekebank_payment_version_ffd'] = $this->config->get('payment_berekebank_payment_version_ffd');
$data['paymentMethod_list'] = $this->getPaymentMethodList();
$data['payment_berekebank_payment_method'] = $this->config->get('payment_berekebank_payment_method');
$data['payment_berekebank_payment_method_delivery'] = $this->config->get('payment_berekebank_payment_method_delivery');
$data['paymentObject_list'] = $this->getPaymentObjectList();
$data['payment_berekebank_payment_object'] = $this->config->get('payment_berekebank_payment_object');
$data['report'] = $this->getReport();
$data['header'] = $this->load->controller('common/header');
$data['column_left'] = $this->load->controller('common/column_left');
$data['footer'] = $this->load->controller('common/footer');
$this->response->setOutput($this->load->view('extension/id_payment_berekebank/payment/berekebank_payment', $data));
}
public function save(): void {
$this->load->language('extension/id_payment_berekebank/payment/berekebank_payment');
$json = [];
if (!$this->user->hasPermission('modify', 'extension/id_payment_berekebank/payment/berekebank_payment')) {
$json['error'] = $this->language->get('error_permission');
}
if (!$json) {
$this->load->model('setting/setting');
$this->model_setting_setting->editSetting('payment_berekebank_payment', $this->request->post);
$Gateway = new Gateway();
$url = new Url(HTTP_CATALOG);
$callback_addresses_string = $url->link('extension/id_payment_berekebank/payment/berekebank_payment.callback');
$Gateway->_updateGatewaySettings($callback_addresses_string, $this->request->post);
$json['success'] = $this->language->get('text_success');
}
$this->response->addHeader('Content-Type: application/json');
$this->response->setOutput(json_encode($json));
}
public function install(): void {
if ($this->user->hasPermission('modify', 'extension/payment')) {
$this->load->model('extension/id_payment_berekebank/payment/berekebank_payment');
$this->model_extension_id_payment_berekebank_payment_berekebank_payment->install();
$this->load->model('setting/event');
$event_data = array(
'code' => 'extension_id_payment_berekebank_order',
'trigger' => 'admin/view/sale/order_info/after',
'action' => 'extension/id_payment_jccgateway/payment/jccgateway_payment.order',
'status' => 1,
'sort_order' => 0,
'description' => ''
);
$this->model_setting_event->addEvent($event_data);
}
}
public function uninstall(): void {
if ($this->user->hasPermission('modify', 'extension/payment')) {
$this->load->model('extension/id_payment_berekebank/payment/berekebank_payment');
$this->model_extension_id_payment_berekebank_payment_berekebank_payment->uninstall();
}
}
public function order(string &$route, array &$data, string &$output): void
{
$this->load->language('extension/id_payment_berekebank/payment/berekebank_payment');
if (isset($this->request->get['order_id'])) {
$order_id = (int)$this->request->get['order_id'];
} else {
$order_id = 0;
}
$this->load->model('extension/id_payment_berekebank/payment/berekebank_payment');
$data['gateway_order'] = $this->model_extension_id_payment_berekebank_payment_berekebank_payment->getGatewayOrder($order_id);
if (!empty($data['gateway_order'])) {
$this->load->model('sale/order');
$order_info = $this->model_sale_order->getOrder($order_id);
$data['order_info'] = $order_info;
if (!empty($data['gateway_order']['status_deposited'])) {
$amount = $data['gateway_order']['order_amount_deposited'];
} else {
$amount = $data['gateway_order']['order_amount'];
}
if (!empty($data['gateway_order']['status_refunded'])) {
$amount -= $data['gateway_order']['order_amount_refunded'];
}
$amount = (int)($amount / 100);
$data['http_server'] = HTTP_SERVER;
$data['store_id'] = $order_info['store_id'];
$data['help_idd_amount'] = sprintf($this->language->get('help_idd_amount'), $amount, $amount, $data['gateway_order']['currency']);
$data['gateway_amount'] = $amount;
$data['user_token'] = $this->request->get['user_token'];
$data['order_id'] = $this->request->get['order_id'];
$berekebank_payment_method_content = $this->load->view('extension/id_payment_berekebank/payment/berekebank_payment_order', $data);
if (strpos($output, "#tab-idd-payment-method") !== false) {
return;
}
$tab_html = '<li class="nav-item"><a href="#tab-idd-payment-method" class="nav-link" data-bs-toggle="tab">' . $this->language->get('text_payment_management') . '</a></li>';
$pattern = '/<li class="nav-item"><a href="#tab-additional" data-bs-toggle="tab" class="nav-link">\w+<\/a><\/li>/';
$output = preg_replace($pattern, '$0' . "\n\t\t  " . $tab_html, $output);
$output = str_replace('<div id="tab-history"', $berekebank_payment_method_content . '<div id="tab-history"', $output);
}
}
public function gatewayOrderAction()
{
$this->load->language('extension/id_payment_berekebank/payment/berekebank_payment');
$this->load->model('extension/id_payment_berekebank/payment/berekebank_payment');
$this->load->model('sale/order');
$gateway_order = $this->model_extension_id_payment_berekebank_payment_berekebank_payment->getGatewayOrder($this->request->get['order_id']);
$order_info = $this->model_sale_order->getOrder($this->request->get['order_id']);
if ($gateway_order && $order_info && !empty($this->request->post['order_action'])) {
$gateway_order['order_amount'] = (int)round($gateway_order['order_amount']);
$parameters = array();
$parameters['orderId'] = trim($gateway_order['gateway_order_reference']);
if (!empty($this->config->get('payment_berekebank_payment_merchant_token'))) {
$decoded_credentials = base64_decode($this->config->get('payment_berekebank_payment_merchant_token'));
list($l, $p) = explode(':', $decoded_credentials);
$parameters['userName'] = $l;
$parameters['password'] = $p;
} else {
$parameters['userName'] = $this->config->get('payment_berekebank_payment_merchant_login');
$parameters['password'] = $this->config->get('payment_berekebank_payment_merchant_password');
}
$order_action = trim($this->request->post['order_action']);
$test_mode = $this->config->get('payment_berekebank_payment_test_mode') == '1' ? true : false;
$Gateway = new Gateway();
if ($test_mode) {
$action_adr = $Gateway->getTestUrl();
} else {
$action_adr = $Gateway->getProdUrl();
}
if ($order_action == 'payment_status') {
$response = $Gateway->_sendGatewayData($parameters, $action_adr . "getOrderStatusExtended.do");
$response = json_decode($response, true);
if (!empty($response['orderNumber'])
&& isset($response['orderStatus'])
&& (int)$order_info['order_id'] == (int)explode("_", $response['orderNumber'])[0]) {
$json['success'] = "Gateway transaction status is: " . $response['paymentAmountInfo']['paymentState'];
} else {
$json['error'] = "(" . $response['errorCode'] . ") " . $response['errorMessage'];
}
} elseif (strpos($order_action, 'payment_deposit') !== false && empty($gateway_order['status_deposited'])) {
if ($order_action == 'payment_deposit_partial') {
$user_amount = (float)str_replace(',', '.', trim($this->request->post['user_amount'])) * 100;
} else {
$user_amount = 0;
}
if ($gateway_order['order_amount'] < $user_amount) {
$json['error'] = sprintf($this->language->get('error_invalid_refund_amount'), number_format((int)$gateway_order['order_amount'] / 100 , 2));
$this->response->setOutput(json_encode($json));
return;
}
$parameters['amount'] = intval($user_amount);
$response = $Gateway->_sendGatewayData($parameters, $action_adr . "deposit.do");
$response = json_decode($response, true);
if (!empty($response) && isset($response['errorCode'])) {
if (empty($response['errorCode'])) {
$json['success'] = $this->language->get('text_success_deposit');
$json['redirect'] = 1;
$sql_data = array(
'order_amount_deposited' => ($order_action == 'payment_deposit_partial' ? $user_amount : $gateway_order['order_amount']),
'status_deposited' => 1,
'status_reversed' => 0,
);
$this->model_extension_id_payment_berekebank_payment_berekebank_payment->updateGatewayOrder($order_info['order_id'], $sql_data);
$json['history'] = array(
'order_status_id' => $this->config->get('payment_berekebank_payment_approved_status_id'),
'comment' => sprintf($this->language->get('text_success_deposit_amount'), number_format(($order_action == 'payment_deposit_partial' ? $user_amount : $gateway_order['order_amount']) / 100, 2)),
'notify' => 0,
);
} else {
$json['error'] = "(" . $response['errorCode'] . ") " . $response['errorMessage'];
}
}
} elseif (strpos($order_action, 'payment_refund') !== false) {
if ($order_action == 'payment_refund_partial') {
$user_amount = (float)str_replace(',', '.', trim($this->request->post['user_amount'])) * 100;
} else {
$user_amount = $gateway_order['order_amount_deposited'];
if (!empty($gateway_order['status_refunded'])) {
$user_amount -= $gateway_order['order_amount_refunded'];
}
}
if ($gateway_order['order_amount_deposited'] < $user_amount + $gateway_order['order_amount_refunded']) {
$json['error'] = sprintf($this->language->get('error_invalid_refund_amount'), number_format((int)($gateway_order['order_amount_deposited'] - $gateway_order['order_amount_refunded']) / 100 , 2));
$this->response->setOutput(json_encode($json));
return;
}
$parameters['amount'] = intval($user_amount);
$response = $Gateway->_sendGatewayData($parameters, $action_adr . "refund.do");
$response = json_decode($response, true);
if (!empty($response) && isset($response['errorCode'])) {
if (empty($response['errorCode'])) {
$json['success'] = $this->language->get('text_success_refund');
$json['redirect'] = 1;
$sql_data = array(
'order_amount_refunded' => $user_amount + $gateway_order['order_amount_refunded'],
'status_refunded' => 1,
'status_reversed' => 1,
);
if ($gateway_order['order_amount_deposited'] == $sql_data['order_amount_refunded']) {
$sql_data['status'] = 1;
}
$this->model_extension_id_payment_berekebank_payment_berekebank_payment->updateGatewayOrder($order_info['order_id'], $sql_data);
$json['history'] = array(
'order_status_id' => $this->config->get('payment_berekebank_payment_refunded_status_id'),
'comment' => sprintf($this->language->get('text_success_refund_amount'), number_format($user_amount / 100, 2) ),
'notify' => 0,
);
} else {
$json['error'] = "(" . $response['errorCode'] . ") " . $response['errorMessage'];
}
}
} elseif ($order_action == 'payment_reverse') {
$response = $Gateway->_sendGatewayData($parameters, $action_adr . "reverse.do");
$response = json_decode($response, true);
if (!empty($response) && isset($response['errorCode'])) {
if (empty($response['errorCode'])) {
$json['success'] = $this->language->get('text_success_reverse');
$json['redirect'] = 1;
$sql_data = array(
'order_amount_deposited' => 0.00,
'status_deposited' => 0,
'status_reversed' => 0,
);
$response = $Gateway->_sendGatewayData($parameters, $action_adr . "getOrderStatusExtended.do");
$response = json_decode($response, true);
if (!empty($response['orderNumber'])
&& isset($response['orderStatus'])
&& (int)$order_info['order_id'] == (int)explode("_", $response['orderNumber'])[0]
&& (int)$response['orderStatus'] === 3) {
$sql_data['status'] = 1;
$sql_data['status_reversed'] = 1;
}
$this->model_extension_id_payment_berekebank_payment_berekebank_payment->updateGatewayOrder($order_info['order_id'], $sql_data);
$json['history'] = array(
'order_status_id' => $this->config->get('payment_berekebank_payment_reversed_status_id'),
'comment' => $this->language->get('text_success_reverse'),
'notify' => 0,
);
} else {
$json['error'] = "(" . $response['errorCode'] . ") " . $response['errorMessage'];
}
}
}
}
if (!isset($json['success']) && !isset($json['error'])) {
$json['error'] = $this->language->get('error_order_missing');
}
$this->response->setOutput(json_encode($json));
}
/**
* @return array
*/
private function getTaxTypeList()
{
return [
[
'numeric' => 0,
'alphabetic' => $this->language->get('entry_no_vat')
],
[
'numeric' => 1,
'alphabetic' => $this->language->get('entry_vat0')
],
[
'numeric' => 2,
'alphabetic' => $this->language->get('entry_vat10')
],
[
'numeric' => 3,
'alphabetic' => $this->language->get('entry_vat18')
],
[
'numeric' => 4,
'alphabetic' => $this->language->get('entry_vat10_110')
],
[
'numeric' => 5,
'alphabetic' => $this->language->get('entry_vat18_118')
],
[
'numeric' => 6,
'alphabetic' => $this->language->get('entry_vat20')
],
[
'numeric' => 7,
'alphabetic' => $this->language->get('entry_vat20_120')
],
];
}
/**
* @return array
*/
private function getTaxSystemList()
{
return [
[
'numeric' => 0,
'alphabetic' => $this->language->get('entry_tax_system_1')
],
[
'numeric' => 1,
'alphabetic' => $this->language->get('entry_tax_system_2')
],
[
'numeric' => 2,
'alphabetic' => $this->language->get('entry_tax_system_3')
],
[
'numeric' => 3,
'alphabetic' => $this->language->get('entry_tax_system_4')
],
[
'numeric' => 4,
'alphabetic' => $this->language->get('entry_tax_system_5')
],
[
'numeric' => 5,
'alphabetic' => $this->language->get('entry_tax_system_6')
],
];
}
/**
* @return array
*/
private function getVersionFfdList()
{
return [
[
'value' => 'v1_05',
'title' => 'v1.05'
],
[
'value' => 'v1_2',
'title' => 'v1.2'
],
];
}
/**
* @return array
*/
private function getPaymentMethodList()
{
return [
[
'numeric' => 1,
'alphabetic' => $this->language->get('entry_payment_method_1')
],
[
'numeric' => 2,
'alphabetic' => $this->language->get('entry_payment_method_2')
],
[
'numeric' => 3,
'alphabetic' => $this->language->get('entry_payment_method_3')
],
[
'numeric' => 4,
'alphabetic' => $this->language->get('entry_payment_method_4')
],
[
'numeric' => 5,
'alphabetic' => $this->language->get('entry_payment_method_5')
],
[
'numeric' => 6,
'alphabetic' => $this->language->get('entry_payment_method_6')
],
[
'numeric' => 7,
'alphabetic' => $this->language->get('entry_payment_method_7')
],
];
}
/**
* @return array
*/
private function getPaymentObjectList()
{
return [
[
'numeric' => 1,
'alphabetic' => $this->language->get('entry_payment_object_1')
],
[
'numeric' => 2,
'alphabetic' => $this->language->get('entry_payment_object_2')
],
[
'numeric' => 3,
'alphabetic' => $this->language->get('entry_payment_object_3')
],
[
'numeric' => 4,
'alphabetic' => $this->language->get('entry_payment_object_4')
],
[
'numeric' => 5,
'alphabetic' => $this->language->get('entry_payment_object_5')
],
[
'numeric' => 7,
'alphabetic' => $this->language->get('entry_payment_object_7')
],
[
'numeric' => 9,
'alphabetic' => $this->language->get('entry_payment_object_9')
],
[
'numeric' => 10,
'alphabetic' => $this->language->get('entry_payment_object_10')
],
[
'numeric' => 12,
'alphabetic' => $this->language->get('entry_payment_object_12')
],
[
'numeric' => 13,
'alphabetic' => $this->language->get('entry_payment_object_13')
],
];
}
public function report(): void {
$this->load->language('extension/id_payment_berekebank/payment/berekebank_payment');
$this->response->setOutput($this->getReport());
}
public function getReport(): string {
if (isset($this->request->get['page'])) {
$page = (int)$this->request->get['page'];
} else {
$page = 1;
}
$data['reports'] = [];
$this->load->model('extension/id_payment_berekebank/payment/berekebank_payment');
$results = $this->model_extension_id_payment_berekebank_payment_berekebank_payment->getReports(($page - 1) * 10, 10);
foreach ($results as $result) {
$data['reports'][] = [
'order_id'   => $result['order_id'],
'card'       => $result['card'],
'amount'     => $this->curency->format($result['amount'], $this->config->get('config_currency')),
'response'   => $result['response'],
'status'     => $result['order_status'],
'date_added' => date($this->language->get('datetime_format'), strtotime($result['date_added'])),
'order'      => $this->url->link('sale/order.info', 'user_token=' . $this->session->data['user_token'] . '&order_id=' . $result['order_id'])
];
}
$report_total = $this->model_extension_id_payment_berekebank_payment_berekebank_payment->getTotalReports();
$data['pagination'] = $this->load->controller('common/pagination', [
'total' => $report_total,
'page'  => $page,
'limit' => $this->config->get('config_pagination_admin'),
'url'   => $this->url->link('extension/id_payment_berekebank/payment/berekebank_payment.report', 'user_token=' . $this->session->data['user_token'] . '&page={page}')
]);
$data['results'] = sprintf($this->language->get('text_pagination'), ($report_total) ? (($page - 1) * 10) + 1 : 0, ((($page - 1) * 10) > ($report_total - 10)) ? $report_total : ((($page - 1) * 10) + 10), $report_total, ceil($report_total / 10));
return $this->load->view('extension/id_payment_berekebank/payment/berekebank_payment_report', $data);
}
}
